// MapTool_3DView.cpp : implementation of the CMapTool_3DView class
//

#include "stdafx.h"
#include "MapTool_3D.h"

#include "MapTool_3DDoc.h"
#include "MapTool_3DView.h"
#include "..\\MapTool_3D\\3D_Core\\CCamera.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMapTool_3DView

IMPLEMENT_DYNCREATE(CMapTool_3DView, CView)

BEGIN_MESSAGE_MAP(CMapTool_3DView, CView)
	// Standard printing commands
	ON_WM_ENDSESSION()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_CAMERA_1PERSON, &CMapTool_3DView::OnCamera1person)
	ON_COMMAND(ID_CAMERA_AIRCRAFTMODE, &CMapTool_3DView::OnCameraAircraftmode)
	ON_COMMAND(ID_CAMERA_3PERSONEYE, &CMapTool_3DView::OnCamera3personeye)
	ON_COMMAND(ID_FILLMODE_SOLID, &CMapTool_3DView::OnFillmodeSolid)
	ON_COMMAND(ID_FILLMODE_WIREFRAME, &CMapTool_3DView::OnFillmodeWireframe)
	ON_COMMAND(ID_MINFILTER_NONE, &CMapTool_3DView::OnMinfilterNone)
	ON_COMMAND(ID_MINFILTER_POINT, &CMapTool_3DView::OnMinfilterPoint)
	ON_COMMAND(ID_MINFILTER_LINEAR, &CMapTool_3DView::OnMinfilterLinear)
	ON_COMMAND(ID_MINFILTER_ANISOTROPIC, &CMapTool_3DView::OnMinfilterAnisotropic)
	ON_COMMAND(ID_MAGFILTER_NONE, &CMapTool_3DView::OnMagfilterNone)
	ON_COMMAND(ID_MAGFILTER_POINT, &CMapTool_3DView::OnMagfilterPoint)
	ON_COMMAND(ID_MAGFILTER_LINEAR, &CMapTool_3DView::OnMagfilterLinear)
	ON_COMMAND(ID_MAGFILTER_ANISOTROPIC, &CMapTool_3DView::OnMagfilterAnisotropic)
	ON_COMMAND(ID_MAXANISOTROPY_1, &CMapTool_3DView::OnMaxanisotropy1)
	ON_COMMAND(ID_MAXANISOTROPY_2, &CMapTool_3DView::OnMaxanisotropy2)
	ON_COMMAND(ID_MAXANISOTROPY_4, &CMapTool_3DView::OnMaxanisotropy4)
	ON_COMMAND(ID_MAXANISOTROPY_8, &CMapTool_3DView::OnMaxanisotropy8)
	ON_COMMAND(ID_MAXANISOTROPY_16, &CMapTool_3DView::OnMaxanisotropy16)
	ON_COMMAND(ID_MAXANISOTROPY_32, &CMapTool_3DView::OnMaxanisotropy32)
	ON_COMMAND(ID_MAXANISOTROPY_64, &CMapTool_3DView::OnMaxanisotropy64)
	ON_COMMAND(ID_MIPFILTER_NONE, &CMapTool_3DView::OnMipfilterNone)
	ON_COMMAND(ID_MIPFILTER_POINT, &CMapTool_3DView::OnMipfilterPoint)
	ON_COMMAND(ID_MIPFILTER_LINEAR, &CMapTool_3DView::OnMipfilterLinear)
	ON_COMMAND(ID_COLOROP_ADDSIGNED, &CMapTool_3DView::OnColoropAddsigned)
	ON_COMMAND(ID_COLOROP_ADDSIGNED2X, &CMapTool_3DView::OnColoropAddsigned2x)
	ON_COMMAND(ID_COLOROP_ADD, &CMapTool_3DView::OnColoropAdd)
	ON_COMMAND(ID_COLOROP_SUBTRACT, &CMapTool_3DView::OnColoropSubtract)
	ON_COMMAND(ID_COLOROP_MODULATE, &CMapTool_3DView::OnColoropModulate)
	ON_COMMAND(ID_COLOROP_MODULATE2X, &CMapTool_3DView::OnColoropModulate2x)
	ON_COMMAND(ID_COLOROP_MODULATE4X, &CMapTool_3DView::OnColoropModulate4x)
	ON_COMMAND(ID_RENDERMODE_SINGLEPASS, &CMapTool_3DView::OnRendermodeSinglepass)
	ON_COMMAND(ID_RENDERMODE_MULTIPASS, &CMapTool_3DView::OnRendermodeMultipass)
END_MESSAGE_MAP()

// CMapTool_3DView construction/destruction

CMapTool_3DView::CMapTool_3DView()
{
	// TODO: add construction code here

}

CMapTool_3DView::~CMapTool_3DView()
{
}

BOOL CMapTool_3DView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CMapTool_3DView printing

BOOL CMapTool_3DView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMapTool_3DView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMapTool_3DView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CMapTool_3DView diagnostics

#ifdef _DEBUG
void CMapTool_3DView::AssertValid() const
{
	CView::AssertValid();
}

void CMapTool_3DView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMapTool_3DDoc* CMapTool_3DView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMapTool_3DDoc)));
	return (CMapTool_3DDoc*)m_pDocument;
}
#endif //_DEBUG

// CMapTool_3DView message handlers

void CMapTool_3DView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	// 3D ʱȭ
	
	// Initialise the engine.
	HWND hWnd = GetSafeHwnd();
	CRect rc;
	GetWindowRect(rc);
	g_App.InitInstance(hWnd, rc);
  
}

// CMapTool_3DView drawing

void CMapTool_3DView::OnDraw(CDC* /*pDC*/)
{
	CMapTool_3DDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	
	// TODO: add draw code for native data here
	// Begin the gameplay process. Will return when app due to exit.
    g_App.FrameAdvance();

	this->Invalidate(0);
}

void CMapTool_3DView::OnEndSession(BOOL bEnding)
{
	CView::OnEndSession(bEnding);

	// TODO: Add your message handler code here 
	// Shut down the engine, just to be polite, before exiting.
    if ( !g_App.ShutDown() )  MessageBox(L"Failed to shut system down correctly, please check file named 'debug.txt'.\r\n\r\nIf the problem persists, please contact technical support.", L"Non-Fatal Error");

}

void CMapTool_3DView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	bool isMin;
	nType == SIZE_MINIMIZED ? isMin = true : isMin = false; 
	CRect rc;
	GetWindowRect(rc);
//	g_App.SetSize(isMin, rc);			// ̴  ⼭ . (1)
}

void CMapTool_3DView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CView::OnLButtonDown(nFlags, point);
	g_App.Mouse_Lift_Down();
}

void CMapTool_3DView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CView::OnLButtonUp(nFlags, point);
	g_App.Mouse_Lift_Up();
}

void CMapTool_3DView::OnCamera1person()
{
	// TODO: Add your command handler code here
	g_App.Camera_Mode_Change(CCamera::MODE_FPS);
}

void CMapTool_3DView::OnCameraAircraftmode()
{
	// TODO: Add your command handler code here
	g_App.Camera_Mode_Change(CCamera::MODE_SPACECRAFT);
}

void CMapTool_3DView::OnCamera3personeye()
{
	// TODO: Add your command handler code here
	g_App.Camera_Mode_Change(CCamera::MODE_THIRDPERSON);	
}

void CMapTool_3DView::OnFillmodeSolid()
{
	// TODO: Add your command handler code here
	g_App.m_FillMode = D3DFILL_SOLID;
    g_App.Change_Direct3D();
}

void CMapTool_3DView::OnFillmodeWireframe()
{
	// TODO: Add your command handler code here
	g_App.m_FillMode = D3DFILL_WIREFRAME;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMinfilterNone()
{
	// TODO: Add your command handler code here
	g_App.m_MinFilter = D3DTEXF_NONE;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMinfilterPoint()
{
	// TODO: Add your command handler code here
	g_App.m_MinFilter = D3DTEXF_POINT;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMinfilterLinear()
{
	// TODO: Add your command handler code here
	g_App.m_MinFilter = D3DTEXF_LINEAR;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMinfilterAnisotropic()
{
	// TODO: Add your command handler code here
	g_App.m_MinFilter = D3DTEXF_ANISOTROPIC;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMagfilterNone()
{
	// TODO: Add your command handler code here
	g_App.m_MagFilter = D3DTEXF_NONE;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMagfilterPoint()
{
	// TODO: Add your command handler code here
	g_App.m_MagFilter = D3DTEXF_POINT;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMagfilterLinear()
{
	// TODO: Add your command handler code here
	g_App.m_MagFilter = D3DTEXF_LINEAR;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMagfilterAnisotropic()
{
	// TODO: Add your command handler code here
	g_App.m_MagFilter = D3DTEXF_ANISOTROPIC;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy1()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 1;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy2()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 2;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy4()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 4;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy8()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 8;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy16()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 16;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy32()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 32;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMaxanisotropy64()
{
	// TODO: Add your command handler code here
	g_App.m_Anisotropy = 64;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMipfilterNone()
{
	// TODO: Add your command handler code here
	g_App.m_MipFilter = D3DTEXF_NONE;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMipfilterPoint()
{
	// TODO: Add your command handler code here
	g_App.m_MipFilter = D3DTEXF_POINT;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnMipfilterLinear()
{
	// TODO: Add your command handler code here
	g_App.m_MipFilter = D3DTEXF_LINEAR;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropAddsigned()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_ADDSIGNED;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropAddsigned2x()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_ADDSIGNED2X;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropAdd()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_ADD;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropSubtract()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_SUBTRACT;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropModulate()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_MODULATE;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropModulate2x()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_MODULATE2X;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnColoropModulate4x()
{
	// TODO: Add your command handler code here
	g_App.m_ColorOp  = D3DTOP_MODULATE4X;
	g_App.SetupRenderStates();
}

void CMapTool_3DView::OnRendermodeSinglepass()
{
	// TODO: Add your command handler code here
	g_App.Change_Terrian(true);
}

void CMapTool_3DView::OnRendermodeMultipass()
{
	// TODO: Add your command handler code here
	g_App.Change_Terrian(false);
}
