// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MapTool_3D.h"

#include "MainFrm.h"

#include "MapTool_3DDoc.h"
#include "MapTool_3DView.h"
#include "Child_MenuCtrl.h"
//#include "Child_View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
/*
	̷   䰡  پ  ڵ 
	|-----------------------------|
	|      |                      |
	|child |                      |
	| (0,0)|                      |
	|------|        work          |
	|      |                      |
	|child |                      |
	| (1,0)|                      |
	|      |                      |
	|      |                      |
	|-----------------------------|

	*/

	// ø   
	m_wndSplit_Window.CreateStatic(this, 1, 2);
//	m_wndSplit_ChildWindow.CreateStatic(&m_wndSplit_Window, 1, 1,
//				WS_CHILD | WS_VISIBLE, m_wndSplit_Window.IdFromRowCol(0, 0));

	//   ٿֱ
//	m_wndSplit_ChildWindow.CreateView(0, 0, RUNTIME_CLASS(CChild_View), CSize(0, 0), pContext);
	m_wndSplit_Window.CreateView(0, 0, RUNTIME_CLASS(CChild_MenuCtrl), CSize(0, 0), pContext);

	m_wndSplit_Window.CreateView(0, 1, RUNTIME_CLASS(CMapTool_3DView), CSize(0, 0), pContext);

	//  ֱ
	m_wndSplit_Window.SetColumnInfo(0, 310, 0);
//	m_wndSplit_ChildWindow.SetRowInfo(0, 220, 0);

	// ϵ  ȣ   
//	m_pChd_MapView	= (CChild_View *) m_wndSplit_ChildWindow.GetPane(0,0);
	m_pChd_Menu		= (CChild_MenuCtrl *) m_wndSplit_Window.GetPane(0,0);
	m_pChd_Menu->pFrame = this;
	m_pWorkView	= (CMapTool_3DView *) m_wndSplit_Window.GetPane(0,1);
	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers



